=== htdocs/css/timeline.css
==================================================================
--- htdocs/css/timeline.css	(revision 2556)
+++ htdocs/css/timeline.css	(local)
@@ -4,6 +4,8 @@
 #prefs fieldset label { display: block }
 #prefs .buttons { margin-top: -1.6em }
 
+#fullchangesetmessage { margin-left: 1em; }
+
 h2 {
  background: #f7f7f7;
  border-bottom: 1px solid #d7d7d7;
=== templates/timeline.cs
==================================================================
--- templates/timeline.cs	(revision 2556)
+++ templates/timeline.cs	(local)
@@ -14,9 +14,15 @@
  </div>
  <fieldset><?cs
   each:filter = timeline.filters ?>
-   <label><input type="checkbox" name="<?cs var:filter.name ?>"<?cs
+   <label><input type="checkbox" id="<?cs var:filter.name?>" name="<?cs var:filter.name ?>"<?cs
      if:filter.enabled ?> checked="checked"<?cs /if ?> /> <?cs
      var:filter.label ?></label><?cs
+     if:timeline.all_filters.changeset && filter.name == "changeset"
+      ?><label for="fullchangesetmessage"><input id="fullchangesetmessage" type="checkbox" name="fullchangesetmessage" value="1"<?cs
+       if:timeline.fullchangesetmessage
+        ?> checked<?cs
+       /if?> />Show full log message</label><?cs
+     /if ?><?cs
   /each ?>
  </fieldset>
  <div class="buttons">
@@ -24,6 +30,19 @@
  </div>
 </form><?cs
 
+if:timeline.all_filters.changeset
+?><script type="text/javascript">
+ var changeset = document.getElementById("changeset");
+ if (changeset) {
+  var updateChangesetField = function() {
+   enableControl('fullchangesetmessage', changeset.checked);
+  }
+  addEvent(window, 'load', updateChangesetField);
+  addEvent(changeset, 'click', updateChangesetField);
+ }
+</script><?cs
+/if ?><?cs
+
 def:day_separator(date) ?><?cs
  if:date != current_date ?><?cs
   if:current_date ?></dl><?cs /if ?><?cs
=== trac/versioncontrol/web_ui/changeset.py
==================================================================
--- trac/versioncontrol/web_ui/changeset.py	(revision 2556)
+++ trac/versioncontrol/web_ui/changeset.py	(local)
@@ -111,9 +111,18 @@
                                              'changeset_show_files'))
             db = self.env.get_db_cnx()
             repos = self.env.get_repository()
+            if req.args.has_key('changeset'):
+                full_log_message = int(req.args.get('fullchangesetmessage',
+                                                    '0'))
+                req.session['timeline.changelog.fullchangesetmessage'] = \
+                    full_log_message
+            else:
+                full_log_message = int(req.session.get('timeline.changelog.'
+                                       'fullchangesetmessage', '0'))
+            req.hdf['timeline.fullchangesetmessage'] = full_log_message
             for chgset in repos.get_changesets(start, stop):
                 message = chgset.message or '--'
-                if format == 'rss':
+                if format == 'rss' or full_log_message:
                     title = util.Markup('Changeset <em>[%s]</em>: %s',
                                         chgset.rev, util.shorten_line(message))
                     href = self.env.abs_href.changeset(chgset.rev)
=== trac/Timeline.py
==================================================================
--- trac/Timeline.py	(revision 2556)
+++ trac/Timeline.py	(local)
@@ -183,7 +183,9 @@
         add_link(req, 'alternate', rss_href, 'RSS Feed', 'application/rss+xml',
                  'rss')
         for idx,fltr in enumerate(available_filters):
+            enabled = int(fltr[0] in filters)
+            req.hdf['timeline.all_filters.%s' % fltr[0]] = 1
             req.hdf['timeline.filters.%d' % idx] = {'name': fltr[0],
-                'label': fltr[1], 'enabled': int(fltr[0] in filters)}
+                'label': fltr[1], 'enabled': enabled}
 
         return 'timeline.cs', None
